﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Sample118577.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }
        //public ActionResult Grid()
        //{
        //    return PartialView();
        //}
        public ActionResult DataSource(Syncfusion.JavaScript.DataManager dm)
        {
            var DataSource = OrderRepository.GetAllRecords();
            DataResult result = new DataResult();
            DataOperations obj = new DataOperations();
            result.result = obj.Execute(DataSource, dm);
            result.count = DataSource.Count;
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {
            NorthwindDataContext ds = new NorthwindDataContext();

            value.OrderID = ds.Orders.ToList().Last().OrderID + 1;
            OrderRepository.Add(value);
            var data = OrderRepository.GetAllRecords();
            Order ord = new Order
            {
                OrderID = value.OrderID,
                CustomerID = value.CustomerID,
                Freight = value.Freight,
                ShipName = value.ShipName,
                ShipCountry = value.ShipCity
            };
            ds.Orders.InsertOnSubmit(ord);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public List<object> EmployeeID
        {
            get
            {
                var employeeID = new NorthwindDataContext().OrdersViews.Select(s => s.EmployeeID).Distinct().ToList();
                var EmployeeID = new List<object>();
                foreach (var id in employeeID)
                {
                    EmployeeID.Add(new { value = id, text = id });
                }
                return EmployeeID;
            }
        }
        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}